.IFNDEF HELPERS
.EQU HELPERS=1

;helpermacros for data alignment and data access -----------------------------

#define ALIGNED(UNALIGNED,ALIGNSIZE) (( ((UNALIGNED) + (ALIGNSIZE) - 1) / (ALIGNSIZE)) * (ALIGNSIZE))

;for DSEG/ESEG
;->@0: alignment size
.MACRO ALIGN
unaligned:
.ORG ALIGNED(unaligned,(@0))
.ENDMACRO

;for CSEG 
;->@0: alignment size (expected in bytes, not in words!)
.MACRO FLASHALIGN
.ORG ALIGNED(PC,((@0)>>1))
.ENDMACRO

;Helpermacro for declaration of data labels in flash address space
;->@0: name of the flash data label to declare
.MACRO FLASHDATA
.EQU @0 = PC<<1
.ENDMACRO

;helpermacro for "inplace" setup of an interrupt vector ----------------------

;->@0: symbolic name of the interrupt vector to set
.MACRO SETVECTOR
.EQU ISR_@0 = PC
.ORG @0
	rjmp ISR_@0
.ORG ISR_@0
.ENDMACRO

.ENDIF
