.IFNDEF WS28XX_COMPAT
.EQU WS28XX_COMPAT=1

.IFDEF UCSR1A
	;take the existence of UCSR1A symbol as a hint for the existence
	;of (at least) USART0 and USART1  
	.IF WS28XX_USE_USART1
		;interrupt vector
		.IFDEF USART1_UDREAddr
			.EQU WS28XX_UDREAddr=USART1_UDREAddr
		.ELSE
			.EQU WS28XX_UDREAddr=UDRE1Addr
		.ENDIF
		;registers
		.EQU WS28XX_UDR=UDR1
		.EQU WS28XX_UCSRA=UCSR1A
		.EQU WS28XX_UCSRB=UCSR1B
		.EQU WS28XX_UCSRC=UCSR1C
		.EQU WS28XX_UBRRL=UBRR1L
		.EQU WS28XX_UBRRH=UBRR1H
		;bits
		.EQU WS28XX_UDRIE=UDRIE1
		.EQU WS28XX_UDRE=UDRE1
		.EQU WS28XX_UDRE=UDRE1
		.EQU WS28XX_TXC=TXC1
		.EQU WS28XX_TXEN=TXEN1
		.EQU WS28XX_UMSEL0=UMSEL10
		.EQU WS28XX_UMSEL1=UMSEL11
	.ELSE
		;interrupt vector
		.IFDEF USART0_UDREAddr
			.EQU WS28XX_UDREAddr=USART0_UDREAddr
		.ELSE
			.EQU WS28XX_UDREAddr=UDRE0Addr
		.ENDIF
		;registers
		.EQU WS28XX_UDR=UDR0
		.EQU WS28XX_UCSRA=UCSR0A
		.EQU WS28XX_UCSRB=UCSR0B
		.EQU WS28XX_UCSRC=UCSR0C
		.EQU WS28XX_UBRRL=UBRR0L
		.EQU WS28XX_UBRRH=UBRR0H
		;bits
		.EQU WS28XX_UDRIE=UDRIE0
		.EQU WS28XX_UDRE=UDRE0
		.EQU WS28XX_TXC=TXC0
		.EQU WS28XX_TXEN=TXEN0
		.EQU WS28XX_UMSEL0=UMSEL00
		.EQU WS28XX_UMSEL1=UMSEL01
	.ENDIF
.ELSE 
	;interrupt vector
	.EQU WS28XX_UDREAddr=UDREAddr
	;registers
	.EQU WS28XX_UDR=UDR
	.EQU WS28XX_UCSRA=UCSRA
	.EQU WS28XX_UCSRB=UCSRB
	.EQU WS28XX_UCSRC=UCSRC
	.EQU WS28XX_UBRRL=UBRRL
	.EQU WS28XX_UBRRH=UBRRH
	;bits
	.EQU WS28XX_UDRIE=UDRIE
	.EQU WS28XX_UDRE=UDRE
	.EQU WS28XX_TXC=TXC
	.EQU WS28XX_TXEN=TXEN
	.IFDEF UMSEL   ;stupid and dangerous, but bugs in tn2313adef.inc and tn4313def.inc may require this shit 
		.EQU WS28XX_UMSEL0=UMSEL
		.EQU WS28XX_UMSEL1=UMSEL+1
	.ELSE
		.EQU WS28XX_UMSEL0=UMSEL0
		.EQU WS28XX_UMSEL1=UMSEL1
	.ENDIF
.ENDIF

.ENDIF
