.IFNDEF WS28XX_USERCODE
.EQU WS28XX_USERCODE=1

.CSEG

;-----------------------------------------------------------------------------
;->LEDCNT : [RO] zero based number of the LED, data is requested for
;  (RAMPZ): bank pointer to gammatable (required only, if RAMPZ exists and
;           gamma correction is used) 
;<-R0     : red
;  R1     : green
;  YH     : blue
;-----------------------------------------------------------------------------
;Flags/ZH:ZL: free for use
;Maximum runtime is 321 ticks, but consider warnings regarding "extra ticks"
;-----------------------------------------------------------------------------

	ldi YH,0
	lds ZL,divider

	tst LEDCNTL		;framestart?
	brne _setled	;no, use current divider state

	dec ZL			;else divide
	brne _divstore
	ldi ZL,DIVN
	_divstore:
	sts divider,ZL

	_setled:
	cpi ZL,WHITEFRAME
	brne _makewhite
	ldi YH,32		;not to bright (for camera)

	_makewhite:
	mov R0,YH		;all colors same value
	mov R1,YH

.ENDIF
